<template src="./template.html"/>
<style scoped src="./stylesheet.scss" lang="scss"/>

<script>
    import axios from "axios";
    import { required } from 'vuelidate/lib/validators';
    import ContactForm from "../ContactForm/ContactForm";

    export default {
        name: "ShopForm",
        components: {
            ContactForm
        },
        props: {
            value: {
                type: Object
            },
        },
        data() {
            return {
                categories: [],
                paymentTypes: [],
                contactTypes: [],

                /* False -> can make request(is not invalid)
                 * True -> cannot make request(is invalid)
                 */
                contactFormState: false
            }
        },
        validations: {
            value: {
                name: {
                    required
                },
                city: {
                    required
                },
                address: {
                    required
                },
                description: {
                    required
                },
                categoryId: {
                    required
                },
                deliveryDetails: {

                },
                deliveryConditions: {

                },
                paymentTypesId: {
                    required
                }
            }
        },
        mounted() {
            axios({
                method: "GET",
                "url": '/store'
            }).then((response) => {
                this.contactTypes = response.data.contactTypes;
                this.categories = response.data.categories;
                this.paymentTypes = response.data.paymentTypes;
            });
        },
        computed: {
            formState() {
                return this.$v.$invalid || this.contactFormState;
            }
        },
        methods: {
            contactsInputChanged(value) {
                this.contactFormState = value;
            },
            emitFormState() {
                this.$emit('userInput', this.formState);
            }
        }
    }
</script>
